Imports System.Runtime.InteropServices

''' <summary>
''' This is a test-application in VS2013 for VB.net
''' You should specify at least .net-Framework 4.0
''' Mostly it is recommended to use the 32-bit version. So set the 
''' target-CPU to "x86".
''' In this project the EXE will be compiled to the subdirectory 
''' \bin\release\.
''' </summary>
''' <remarks>
''' Copy PDFTEXT.DLL to \bin\release\ (use the 'classical' DLL - not 
''' the .net-version!)
''' You have to copy a TEST.PDF into \bin\release\
''' </remarks>
Public Class Form1

    ' Enumeration for comfortable selection of the export-type
    Public Enum PDFOption As UInt32
        ExtractToFile      = 1
        ExtractToClipboard = 2
        ExtractToString    = 3
    End Enum

    ' Now import the DLL into this project
    <DllImport("PDFtext.dll", 
              CallingConvention:=Runtime.InteropServices.CallingConvention.StdCall, 
              EntryPoint:="GetPDFText")> _
              Shared Function GetPDFText(filename As IntPtr, opt As UInt32, 
                                         hw As UInt32, fast As UInt32, 
                                         target As IntPtr, lspaces As UInt32,
                                         ptitel As IntPtr, pos As UInt32, 
                                         page As UInt32, clock As UInt32, 
                                         blank As UInt32, ende As UInt32, 
                                         wlist As UInt32) As IntPtr
    End Function


    ''' <summary>
    ''' The program starts here. The PDF-text will be exported to clipboard
    ''' </summary>
    ''' <remarks>
    ''' If the Demo-Messagebox appears, then you know that the implementation 
    ''' is working correctly
    ''' </remarks>
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try

            ' specify some important parameters
            Dim marshalQuelle    As IntPtr = Marshal.StringToCoTaskMemUni
                                    (Application.StartupPath + "\test.pdf")
            Dim marshalZiel      As IntPtr = Marshal.StringToCoTaskMemUni
                                    (Application.StartupPath + "\test.txt")
            Dim marshalPageTitle As IntPtr = Marshal.StringToCoTaskMemUni
                                    ("[=== Page ===]")

            ' now extract the text to ASCII-file (use mostly default-
            ' parameters of the DLL)
            Dim marshalReturn As IntPtr = GetPDFText(marshalQuelle, 
                                          PDFOption.ExtractToFile, Nothing, 
                                          Nothing, marshalZiel, Nothing, 
                                          marshalPageTitle, Nothing, Nothing, 
                                          Nothing, Nothing, Nothing, Nothing)

            ' what is the return-value of the DLL? 
            Dim msg As String = Marshal.PtrToStringAnsi(marshalReturn)

            ' Show the result
            TextBox1.Text = msg

        Catch ex As Exception
            TextBox1.Text = "An exception was thrown: " + ex.Message
        End Try
    End Sub

End Class